/**
 * 执行publish命令时，上传子应用的文件到服务器
 * @author yanrong.tian
 * @date 2020/5/16 14:22:00
 */
var fs = require('fs');
var path = require('path');

const dataA = {
  textLength: 0,
  row: 0,
};

var FilesDataTree = function(options) {
  this.outputPath = options.outputPath;
  this.data = [];
  this.readDirs(this.data, this.outputPath);
};
FilesDataTree.prototype = {
  each: function(data, callback) {
    var i, k;
    for (i = 0, k = data.length; i < k; i++) {
      callback.call(this, i);
    }
  },

  readDirs: function(data, dirName) {
    var _this = this;
    const excludes = ['node_modules', 'otisbigscreen'];

    if (
      dirName.indexOf('node_modules') < 0 &&
      dirName.indexOf('otisbigscreen') < 0 &&
      dirName.indexOf('/systemWeb') < 0 &&
      dirName.indexOf('/libs') < 0
    ) {
      const dirs = fs.readdirSync(dirName);
      _this.each(dirs, function(i) {
        var fileName = dirs[i];
        var fileFullName = dirName + '/' + fileName;
        var stat = fs.lstatSync(fileFullName);
        if (stat.isDirectory()) {
          data.push({
            type: 'dir',
            fileName,
            children: [],
          });
          _this.readDirs(data[data.length - 1].children, fileFullName);
        } else {
          _this.setData(data, fileFullName, fileName);
        }
      });
    } else {
      //
    }
  },

  setData: function(data, fileFullName, fileName) {
    if (
      fileFullName.indexOf('.js') >= 0 ||
      fileFullName.indexOf('.less') >= 0 ||
      fileFullName.indexOf('.jsx') >= 0 ||
      fileFullName.indexOf('.json') >= 0 ||
      fileFullName.indexOf('.wxml') >= 0 ||
      fileFullName.indexOf('.wxss') >= 0
    ) {
      let dataBuffer = fs.readFileSync(fileFullName, 'utf-8') || '';
      const textLength = dataBuffer.length;
      const row = dataBuffer.match(/[\r\n]/g) && dataBuffer.match(/[\r\n]/g).length;
      let name = fileFullName.replace('/index.jsx', '');
      name = name.split('/');
      name = name[name.length - 1];
      if (row > 10 && fileFullName.indexOf('/index.jsx') >= 0) {
        var stat = fs.statSync(fileFullName);
        if (stat.mtime) {
          dataBuffer = `
/**
 * ${name}
 * @author tianyanrong
 * @date ${stat.mtime.toLocaleString()}
 */
${dataBuffer}
`;
          fs.writeFileSync(fileFullName, dataBuffer, 'utf-8') || '';
        }
      }
    }
    // const base64 = dataBuffer.toString('base64');
    // data.push({
    //   fileName: fileName,
    //   base64: base64 || '',
    //   type: 'file',
    // });
  },
};
const projectRoot = process.cwd();
new FilesDataTree({
  outputPath: projectRoot,
});
